/*****************************************************************************
 *
 * PSV Demo for PIC24.
 *
 *****************************************************************************
 * FileName:        PSV.c
 * Dependencies:    
 * Processor:       
 * Compiler:       	
 * Linker:          
 * Company:         Microchip Technology Incorporated
 *
 * Software License Agreement
 *
 * The software supplied herewith by Microchip Technology Incorporated
 * (the "Company") is intended and supplied to you, the Company's
 * customer, for use solely and exclusively with products manufactured
 * by the Company. 
 *
 * The software is owned by the Company and/or its supplier, and is 
 * protected under applicable copyright laws. All rights are reserved. 
 * Any use in violation of the foregoing restrictions may subject the 
 * user to criminal sanctions under applicable laws, as well as to 
 * civil liability for the breach of the terms and conditions of this 
 * license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES, 
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED 
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT, 
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR 
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 *
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Vidyadhar		  30/June/06	     ...	
 * Brant Ivey			7/3/07		Updated for v4.0 of class
 *****************************************************************************/

#include <p24FJ128GA010.h>

_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_OFF & ICS_PGx2 & FWDTEN_OFF)
_CONFIG2(IESO_OFF & FCKSM_CSDCMD & OSCIOFNC_ON &  FNOSC_FRC & POSCMOD_NONE)

//##########################################
//	STEP 1:
//	Define an array "MyString" placing
// 	in PSV space and assign a string ("Hello World") to it.
//##########################################

const unsigned char __attribute__ ((space(psv))) MyString[] = "Hello World";    // ###


main()
{
	LCDInit();
	PSVInit();

int i = 0;
	while(MyString[i]!=0)
	{
	  LCDPut(MyString[i]);
	  i++;
	}
	while(1);
}



PSVInit()
{

	//##########################################
	//	STEP 2:
	//	using built-in function load PSVPAG with the page address where the 
	// 	array MyString is placed.
	//##########################################
	
	PSVPAG = __builtin_psvpage(MyString);       // ###

	CORCONbits.PSV = 1;
}	
